
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>vue/react/angular开发的css架构思考 / 憋错料</title>

    <meta name="description" content="vue/react/angular开发的css架构思考 前端开发现在已经从传统的后端web多页面开发模式转向前端单页SPA开发模式,而vuejs/react/angular则是开发SPA非常优秀的前端框架.组件化开发由react最早提出,vuejs后发优势,将组件化开发贯彻到了极致.虽然spa开发由于组件式开发带来的组件重用,可维护,可扩展非常好,但是css样式的管理一直是一个令前端团队头疼的问题,特别是当页面越来越复杂,并且有多个SPA页面时如何能够让样式重用,并且可维护,可扩展并没有一个特别有效和被验证过的普适方案.本文试图总结一些css模块化在">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">vue/react/angular开发的css架构思考</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>前端开发现在已经从传统的后端web多页面开发模式转向前端单页SPA开发模式，而vuejs/react/angular则是开发SPA非常优秀的前端框架。组件化开发由react最早提出，vuejs后发优势，将组件化开发贯彻到了极致。虽然spa开发由于组件式开发带来的组件重用，可维护，可扩展非常好，但是css样式的管理一直是一个令前端团队头疼的问题，特别是当页面越来越复杂，并且有多个SPA页面时如何能够让样式重用，并且可维护，可扩展并没有一个特别有效和被验证过的普适方案。本文试图总结一些css模块化在vuejs开发中的探索。</p>
<p>1. 由于一般会有一个app组件作为整个vue应用的container,因此一些全局性的css样式，最好在这个app组件中定义；</p>
<p>2. 完全组件化开发，将每一个vue组件都作为独立可重用单元对待，css也不例外。组件相关的css就在vue的style定义块中进行定义和开发，并且每个组件的root元素都给一个class定义，css的定义都应用在这个class里面，这样可以实现样式的隔离；</p>
<p>3. 在less/sass文件中单独定义包含color,margin,fontsize等外观属性的公共定义文件，比如globalcde.less文件，这个文件可以通过sass-resources-loader来实现在所有vue组件中可见，并且加以引用。这样做的好处是所有用户感知的全局皮肤都在一个中央控制的文件中定义，一旦需要修改设计，只要在这个文件中修改对应变量。但是需要注意的是，在vue组件设计时，不能随意hard coded了，而是需要引用这里定义的color, margin,fontsize等定义！</p>
<p>4. 一般来说，我们可能会引用类似element-ui,ant-design等组件库，这时如何既能享受到这些成熟组件带来的快速开发便利，又能定制这些组件从而适应我们自己的品牌色系呢？一个可行的思路是通过调用这些组件库的api，使用上面第3步中定义的全局色系来定制第三方组件库的theme</p>

<p>原文地址：https://www.cnblogs.com/kidsitcn/p/10961517.html</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-28 12:25:26 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/color/" title="color">color</a>, <a href="https://www.biecuoliao.com/tag/%e4%b8%8d%e8%83%bd/" title="不能">不能</a>, <a href="https://www.biecuoliao.com/tag/class/" title="class">class</a>, <a href="https://www.biecuoliao.com/tag/%e5%bc%80%e5%8f%91/" title="开发">开发</a>, <a href="https://www.biecuoliao.com/tag/%e9%80%82%e5%ba%94/" title="适应">适应</a>, <a href="https://www.biecuoliao.com/tag/%e5%bf%ab%e9%80%9f/" title="快速">快速</a>, <a href="https://www.biecuoliao.com/tag/resource/" title="resource">resource</a>, <a href="https://www.biecuoliao.com/tag/%e6%a8%a1%e5%9d%97%e5%8c%96/" title="模块化">模块化</a>, <a href="https://www.biecuoliao.com/tag/theme/" title="theme">theme</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>vue/react/angular开发的css架构思考的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4JdYZY0.html" rel="bookmark">vue react angular对比</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.数据绑定 1)vue 把一个普通对象传给Vued的data选项,Vue会遍历此对象的所有属性,并使用Object.defineProperty将这些属性全部转为getter/setter.Object.defineProperty为ES5的新属性,无法模仿,所以vue不支持IE8以及更低版本浏览器的原因.用户看不到getter和setter但是vue内部做了追踪依赖,在属性被访问和修改时通知变化.每个组件都有一个watcher对象,他会在组件渲染的过程中把属性记录为依赖,之后当该属性的set			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0klwBl3.html" rel="bookmark">vue&comma;react&comma;angular，windows 环境本地配置单页面应用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.起因:项目使用VUE,和react.构建单页面应用.在nginx的环境下只有一个index.html入口.这时候默认能够访问到vue,和react 路由 配置中的首页.内部连接也能够跳转但是不能给刷新也面.刷新页面后就为变为404页面. 二.原因:nginx 在解析路径的时候:比如: localhost/a     这个路由.其实nginx 在解析路径 时候.为去root根路径下去找a文件.但是找不到.所有就会报错. 但是在单页面应用中localhost/a 其实是 VUE, 和react			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qB9974.html" rel="bookmark">前端如何入门面对传统的html，css，js，三大框架react，vue，angular？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前端入门需要学习 A基础知识部分 1.html一些新的标签,html不仅仅包括div,span 2.css3,一些新的语法,布局,例如flex弹性布局,less,sass都是啥 3.DOM树结构,盒模型(margin,padding,border)不同浏览器层次不一样,尤其IE 4.数据交互插件,ajax,fetch,axios等等,要求自己能封装出一个ajax类,供自己用 B前端环境,软件 nodejs,npm 1.了解node,npm是干什么的,为什么前端要用这些 2.自己搜索npm官网,c			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/476KRk3.html" rel="bookmark">前端三大主流框架的对比React、Vue、Angular</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前端三大主流框架的对比React.Vue.Angular React 起源于 Facebook 的内部项目,用来架设 Instagram 的网站, 并于 2013年 5 月开源.React 拥有较高的性能,代码逻辑非常简单,越来越多的人已开始关注和使用它.它有以下的特性: 1.声明式设计:React采用声明范式,可以轻松描述应用. 2.高效:React通过对DOM的模拟,最大限度地减少与DOM的交互. 3.灵活:React可以与已知的库或框架很好地配合. 优点: 1. 速度快:在UI渲染过程中,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4perEJM.html" rel="bookmark">2015前端各大框架比较（angular&comma;vue&comma;react&comma;ant）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前端流行框架大比拼 angular vue react ant-design angularjs angular是个MVVM的框架.针对的是MVVM这整个事.angular的最主要的场景就是单页应用,或是有大量数据绑定的情况. 特性 双向数据绑定 ioc依赖注入 指令 上面这几点用起来确实很爽,随便指定个区域,配一个controller,然后里面的东西就都在scrope里了,确实很方便 如果各位想看,参见 https://github.com/i5ting/ionic_ninja/blob/ma			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xZmJz4.html" rel="bookmark">Vue&period;js与angular在数据实现的思考</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Vue.js,其简洁的API以及活跃的社区,对于打算从angular转向Vue还是挺友好的,打算最近一段时间去整理下Vue自己的一些思考,加深下对于此的印象. Vue与Angular同属于MVVM框架,MVVM的本质是通过数据绑定链接View和Model,让数据的变化自动映射为视图的更新.Vue.js在数据绑定的API设计上借鉴了Angular的指令机制:用户可以通过具有特殊前缀的HTML 属性来实现数据绑定,也可以使用常见的花括号模板插值,或是在表单元素上使用双向绑定: &lt;!-- 指令 --&gt			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBBd7ZM.html" rel="bookmark">主流前端框架对比：Vue&period;js &comma; React&comma; Angular&period;js</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				个人认为Vue.js的文档最恳切.我认为结合文档和遇到问题Google答案的匹配度来讲:Vue.js &gt; ReactJS &gt; AngularJS &gt; Angular 2 如何使用Vue.js? 1.安装 (1)script 如果项目直接通过script加载CDN文件,代码示例如下: &lt;script src=&quot;http://webapp.didistatic.com/static/webapp/shield/z/vue/vue/1.0.24/vue.min.js&quot;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41wwjk0.html" rel="bookmark">基于webpack和vue&period;js搭建开发环境</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 在对着产品高举中指怒发心中之愤后,真正能够解决问题的是自身上的改变,有句话说的好:你虽然改变不了全世界,但是你有机会改变你自己.秉承着“不听老人言,吃亏在眼前”的优良作风,我还是决定玩火自焚. 问题所在 之前的项目总结为以下内容: 1.AMD模块规范开发,使用requirejs实现,使用rjs打包,最终导致的结果是,输出的项目臃肿,肿的就像一坨狗不理……不忍直视2.使用gulp进行打包,这一点貌似没有可吐槽的地方,毕竟都是被grunt折磨过来的……3.数据的渲染使用模板引擎,这就意味着你要			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4Ap1xy3.html" rel="bookmark">Vue&comma; React&comma; AngularJS&comma; and Angular2&period; 我们对流行JavaScript框架们的选择</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2017-08-04 前端大全 (点击上方公众号,可快速关注) 英文:ANTONI ZOLCIAK  译文:众成翻译 www.zcfy.cc/article/vue-react-angularjs-and-angular2-our-take-on-popular-javascript-frameworks-3668.html 如有好文章投稿,请点击 → 这里了解详情 一个有趣的事实是:IBM发表的2017年最值得学习的编程语言名单中,JavaScript榜上有名.这位IT巨头指出,JS在网站中惊			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/r0a2Dn3.html" rel="bookmark" class="title">【bzoj1096】仓库建设&mdash;&mdash;斜率优化dp</a>
					<div>
						题目链接 我们用sum[i]表示前i个工厂的产品数之和,b[i]表示x[i]*p[i]的前缀和,因此第j+1~i个工厂的产品运到第i个工厂的代价就是 (sum[i]-sum[j])*x[i]-(b[i ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/g41XYo3.html" rel="bookmark" class="title">EasyUI合并行</a>
					<div>
						扩展一下 EasyUI   下面湿扩展EasyUI 合并行的方法 $.extend($.fn.datagrid.methods, { autoMergeCells: function (jq, fie ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEkKJx3.html" rel="bookmark" class="title">&lbrack;转&rsqb;Eclipse启动Tomcat时45秒超时解决方法</a>
					<div>
						原文地址:http://it.oyksoft.com/post/6577/ Eclipse启动Tomcat时,默认配置的启动超时时长为45秒.假若项目启动超过45秒将会报错.两种解决方法:1.改XML ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/My5ZyYM.html" rel="bookmark" class="title">逆袭指数---杭电校赛（暴力搜索）</a>
					<div>
						Problem Description 这依然是关于高富帅小明曾经的故事—— 尽管身处逆境,但小明一直没有放弃努力,除了搬砖,小明还研究过东方的八卦以及西方的星座,一直试图在命理上找到自己能够逆袭的依 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDZOvo3.html" rel="bookmark" class="title">python抓取网页图片的小案例</a>
					<div>
						1.分析 ,要抓取的页面的信息以及对应的源码信息 blog.sina.com.cn/s/blog 93dc666c0101b1bj.html 2.代码模块: 导入正则表达的模块 导入url相关的模块  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz5Kzl4.html" rel="bookmark" class="title">xxx</a>
					<div>
						let x2 = 100 let y2 = 10.5 let num1 = Double(x2) + y2 let num2 = x2 + Int(y2)					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rk7nv4.html" rel="bookmark" class="title">对于ajax更新的页面，如何实现离线浏览？ 一则方案尝试。</a>
					<div>
						背景 现代页面上越来越多的内容是通过ajax更新, 因为页面可以显示的更加快速, 局部更新, 同时可以实现页面内容的动态性, 增加页面的内容的丰富性. 但是如果将页面内容保存下来, 以备离线浏览器查看 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rZwZl3.html" rel="bookmark" class="title">JAVA中复写equals方法</a>
					<div>
						一般说来,所有类都应该复写Object中的equals方法.步骤大概分三步: 1) 判断两个对象地址是否一致 2)判断第二个对象是否为同一个子类实例 3)判断内容是否一致 class Person { ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xvoJN4.html" rel="bookmark" class="title">hdoj-1159-Common Subsequence【动态规划求最长公共子序列】</a>
					<div>
						Common Subsequence Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others)  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JyWmn3.html" rel="bookmark" class="title">Proxy代理（AOP实现原理）</a>
					<div>
						AOP基于动态代理实现:返回代理对象 java.lang.reflect 包Proxy 类,构造代理类.newProxyInstance() 就是创建代理对象的方法. Proxy.newProxyIn ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02Zpba0.html" rel="bookmark" class="title">ipython  和 Python交互式模式下 键盘方向键乱码的解决方法</a>
					<div>
						解决办法如下: 1.安装readline模块 readline库是bash shell用的库,包含许多功能,如命令行自动补全等. ubuntu下安装的命令: sudo apt-get install  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rZYPa3.html" rel="bookmark" class="title">Hadoop学习笔记之三 数据流向</a>
					<div>
						http://hadoop.apache.org/docs/r1.2.1/api/index.html 最基本的: 1. 文本文件的解析 2. 序列文件的解析 toString会将Byte数组中的内存 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzLEyO3.html" rel="bookmark" class="title">【Docker镜像】docker默认存放路径</a>
					<div>
						docker安装后默认的存放路径为/var/lib/docker,有时候默认情况下磁盘空间有限或规范要求,需要修改docker存放路径.那么请看如下: 1.在ubuntu的主机中可以修改配置文件:/e ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6llKJ3.html" rel="bookmark" class="title">机器视觉--光源</a>
					<div>
						光源基础知识 光源的特性 光源本身的特性,如光源的光谱分布,在被照射面上的亮度分布,光源使用中的温度特性和寿命等. 光源与被照射物体的相互作用.光源照射在物体上,会发生反射.吸收和透射三种相互作用,不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPJarn3.html" rel="bookmark" class="title">mfc 类的析构函数</a>
					<div>
						? 析构函数 ? 自定义析构函数 一.析构函数 析构函数(destructor) 与构造函数相反,当对象生命周期结束时(例如对象所在的函数已调用完毕),系统自动执行析构函数.析构函数往往用来做&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lNXYo4.html" rel="bookmark" class="title">c&sol;c&plus;&plus; 结构体传参问题</a>
					<div>
						c/c++的结构体传参可以有三种方式: 1.传递结构体变量,值传递 2.传递结构体指针,地址传递 3.传递结构体成员,可是值传递也可以是地址传递 根据代码示例: 1.传递结构体变量 1 #includ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyBOwe0.html" rel="bookmark" class="title">windows下Openssl安装过程</a>
					<div>
						环境准备: 1. Perl下载地址http://downloads.activestate.com/ActivePerl/releases/5.16.3.1603/ActivePerl-5.16.3. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02w1Bp3.html" rel="bookmark" class="title">Windows 驱动开发 - 基础1</a>
					<div>
						原来的驱动开发都是WDM(Windows Driver Model)的,那时微软推出DDK(Driver Developer Kit)工具. 现在微软进行了升级由WDF(Windows Driver  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0klpzX3.html" rel="bookmark" class="title">关闭IPV6</a>
					<div>
						[[email protected] ~]# cat &gt; /etc/modprobe.d/ipv6.conf &lt;&lt; EOF alias net-pf-10 off options i ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qOjxpM.html" rel="bookmark" class="title">名片设计尺寸及名片设计的注意事项</a>
					<div>
						一,稿件部分: 1.名片标准尺寸:90mmX54mm 90mmX50mm 90mmX45mm.但是加上出血上下左右各2mm,所以 制作尺寸必须设定为:94 x 58mm 94mmX54mm 94mmX ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.025 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
